﻿

XIncludeFile "../Library/Lizard.pbi"


; Lizard always has to be initialized first.
If Lizard::Initialize("../Library")
	Debug "Lizard kernel has been initialized. Version "+Lizard::Version()
Else
	Debug "Lizard kernel initialization failed!"
	End
EndIf


Procedure Callback_Print(Text.s)                               ; Define a callback function for "Print()" with the content "Text.s"
	Debug "Print:   "+Text
EndProcedure

Procedure Callback_Message(Text.s, SymbolName.s, ErrorName.s)  ; Define a callback function for messages with the content "Text.s", "SymbolName" and "ErrorName"
	Debug "Warning: "+SymbolName+"."+ErrorName+" > "+Text
EndProcedure

Procedure Callback_Error(Text.s)                               ; Define a callback function for errors with the content "Text.s"
	Debug "Error:   "+Text
EndProcedure



Lizard::BindCallback(Lizard::#Event_Print, @Callback_Print())      ; Bind the print callback.
Lizard::BindCallback(Lizard::#Event_Message, @Callback_Message())  ; Bind the message callback.
Lizard::BindCallback(Lizard::#Event_Error, @Callback_Error())      ; Bind the error callback.


Debug Lizard::Evaluate("Print(1, var, 2^100)")         ; Print() uses the bind callback for the output.

Debug Lizard::Evaluate("{1, 2, 3}[4]")                 ; Warning messages are send to the message callback function.

Debug Lizard::Evaluate("2 a")                          ; Errors are send to the error callback function.


; Quit Lizard.
Lizard::Terminate()


; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; Folding = -
; EnableXP
; EnableCompileCount = 145
; EnableBuildCount = 0