﻿

XIncludeFile "../Library/Lizard.pbi"


; Lizard always has to be initialized first.
If Lizard::Initialize("../Library")
	Debug "Lizard kernel has been initialized. Version "+Lizard::Version()
Else
	Debug "Lizard kernel initialization failed!"
	End
EndIf


; // Transfer an array from Pure Basic to a list in Lizard //

Define Dim Numbers.l(3) ; Defining some array.
Numbers(0) = 1
Numbers(1) = 23
Numbers(2) = 456
Numbers(3) = 7890

Debug ""
Lizard::SetMemory("buffer", @Numbers(), SizeOf(Long)*(ArraySize(Numbers())+1))              ; Define the variable "buffer" with the content of the array memory buffer
Debug "Raw memory buffer: " + Lizard::Evaluate("buffer")                                    ; "buffer" contains now a binary string.
Lizard::Evaluate(~"list = ToInteger(#, BinaryFormat->\"int32\") &/@ Partition(buffer, 4)")  ; Partition the buffer and convert the binary strings into integers.
Debug "Lizard list: " + Lizard::Evaluate("list")                                            ; "list" contains now a list of integers from the Pure Basic array.


; // Transfer a list in Lizard to an array in Pure Basic //

Debug ""
Lizard::Evaluate("list = {1.2, 3.45, 6.789, 0.1234, 5.67890}")                              ; Evaluate an assignment of a list with some reals to the variable "list".
Debug "Lizard list: " + Lizard::Evaluate("list")                                            ; "list" contains now a list of reals.
Lizard::Evaluate(~"buffer = Apply(Join, ToString(#, BinaryFormat->\"float64\") &/@ list )") ; Convert the reals into binary strings and join them together.
Debug "Raw memory buffer: " + Lizard::Evaluate("buffer")                                    ; "buffer" contains now a binary string of all reals in double-format.

Define Dim Doubles.d(4)
Lizard::GetMemory("buffer", @Doubles())                                                     ; Fill the array memory buffer with the content of variable "buffer"
Debug "Doubles(0) = "+Doubles(0)
Debug "Doubles(1) = "+Doubles(1)
Debug "Doubles(2) = "+Doubles(2)
Debug "Doubles(3) = "+Doubles(3)
Debug "Doubles(4) = "+Doubles(4)


; Quit Lizard.
Lizard::Terminate()


; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; EnableXP
; EnableCompileCount = 145
; EnableBuildCount = 0