﻿

XIncludeFile "../Library/Lizard.pbi"


; Definition of some callback functions for Lizard (see also Example3_Callbacks.pb)

Procedure Callback_Print(Text.s)
	ConsoleColor(8, 0)
	PrintN(""+Text)
EndProcedure

Procedure Callback_Message(Text.s, SymbolName.s, ErrorName.s)
	ConsoleColor(14, 0)
	Print("  "+SymbolName+"."+ErrorName+"  ")
	ConsoleColor(6, 0)
	PrintN(~"\""+Text+~"\"")
EndProcedure

Procedure Callback_Error(Text.s)
	ConsoleColor(12, 0)
	PrintN(~"  Syntax error: \""+Text+~"\"")
EndProcedure


; Processing the console input into Lizard and then output them.

Procedure Command()
	
	Static EvaluationCount.i = 1
	Protected Input.s, Output.s
	
	PrintN("")
	ConsoleColor(11, 0)
	Print(LSet("In("+EvaluationCount+")", 7)+" :=  ")
	ConsoleColor(15, 0)
	Input = Input()
	Output = Lizard::Evaluate(Input)
	If Output And Output <> "Null"
		ConsoleColor(3, 0)
		Print(LSet("Out("+EvaluationCount+")", 8)+" =  ")
		ConsoleColor(7, 0)
		PrintN(Output)
	EndIf
	EvaluationCount + 1
	
EndProcedure


; Open a console
OpenConsole("Lizard - Console")


; Lizard always has to be initialized first.
If Lizard::Initialize("../Library")
	PrintN( "Lizard kernel has been initialized." )
	PrintN( "Kernel version: "+Lizard::Version() )
Else
	PrintN( "Lizard kernel initialization failed!" )
	Input()
	End
EndIf


; Bind the callbacks
Lizard::BindCallback(Lizard::#Event_Error, @Callback_Error())
Lizard::BindCallback(Lizard::#Event_Message, @Callback_Message())
Lizard::BindCallback(Lizard::#Event_Print, @Callback_Print())


; Main loop
Repeat
	Command()
ForEver


; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; Folding = -
; EnableXP
; Executable = Console.exe
; EnableCompileCount = 183
; EnableBuildCount = 2