﻿

XIncludeFile "../Library/Lizard.pbi"

Procedure Callback_Error(Text.s)                               ; Define a callback function for errors with the content "Text.s"
	Debug "Error:   "+Text
EndProcedure


; Lizard always has to be initialized first.
If Lizard::Initialize("../Library")
	Debug "Lizard kernel has been initialized. Version "+Lizard::Version()
Else
	Debug "Lizard kernel initialization failed!"
	End
EndIf

Lizard::BindCallback(Lizard::#Event_Error, @Callback_Error())      ; Bind the error callback.


Lizard::EvaluateFile("Example7_Script.txt")                        ; Evaluate a whole file with a script which defines functions for the derivative of expressions.
                                                                   ; Errors in this script will be shown in the bind callback function.

Debug Lizard::Evaluate("Derive(x^3+7*x, x)")   ; Let's do some math with derivatives and the script function Derive(expression, variable)
Debug Lizard::Evaluate("Derive(Sin(x)^2, x)")
Debug Lizard::Evaluate("Derive(E^(x^2+x), x)")


; Quit Lizard.
Lizard::Terminate()


; IDE Options = PureBasic 5.73 LTS (Windows - x64)
; Folding = -
; EnableXP
; EnableCompileCount = 162
; EnableBuildCount = 0